EOAPI const Eo_Event_Description _EFL_MODEL_BASE_EVENT_LOAD_STATUS =
   EO_EVENT_DESCRIPTION("load,status", "Event dispatch when load status changes");
EOAPI const Eo_Event_Description _EFL_MODEL_BASE_EVENT_PROPERTIES_CHANGED =
   EO_EVENT_DESCRIPTION("properties,changed", "Event dispatched when properties list is available.");
EOAPI const Eo_Event_Description _EFL_MODEL_BASE_EVENT_CHILD_ADDED =
   EO_EVENT_DESCRIPTION("child,added", "Event dispatched when new child is added.");
EOAPI const Eo_Event_Description _EFL_MODEL_BASE_EVENT_CHILD_REMOVED =
   EO_EVENT_DESCRIPTION("child,removed", "Event dispatched when child is removed.");
EOAPI const Eo_Event_Description _EFL_MODEL_BASE_EVENT_CHILDREN_COUNT_CHANGED =
   EO_EVENT_DESCRIPTION("children,count,changed", "Event dispatched when children count is finished.");
EOAPI EO_FUNC_BODY(efl_model_load_status_get, Efl_Model_Load_Status, 0);
EOAPI EO_FUNC_BODYV(efl_model_properties_get, Efl_Model_Load_Status, 0, EO_FUNC_CALL(properties), Eina_Array * const*properties);
EOAPI EO_FUNC_BODYV(efl_model_property_set, Efl_Model_Load_Status, 0, EO_FUNC_CALL(property, value), const char * property, const Eina_Value *value);
EOAPI EO_FUNC_BODYV(efl_model_property_get, Efl_Model_Load_Status, 0, EO_FUNC_CALL(property, value), const char * property, const Eina_Value **value);
EOAPI EO_FUNC_BODYV(efl_model_children_slice_get, Efl_Model_Load_Status, 0, EO_FUNC_CALL(start, count, children_accessor), unsigned int start, unsigned int count, Eina_Accessor **children_accessor);
EOAPI EO_FUNC_BODYV(efl_model_children_count_get, Efl_Model_Load_Status, 0, EO_FUNC_CALL(children_count), unsigned int *children_count);
EOAPI EO_VOID_FUNC_BODY(efl_model_load);
EOAPI EO_VOID_FUNC_BODY(efl_model_unload);
EOAPI EO_VOID_FUNC_BODY(efl_model_properties_load);
EOAPI EO_VOID_FUNC_BODY(efl_model_children_load);
EOAPI EO_FUNC_BODY(efl_model_child_add, Eo_Base *, 0);
EOAPI EO_FUNC_BODYV(efl_model_child_del, Efl_Model_Load_Status, 0, EO_FUNC_CALL(child), Eo_Base *child);

static Eo_Op_Description _efl_model_base_op_desc[] = {
     EO_OP_FUNC(efl_model_load_status_get, NULL, "Get a load emodel current status."),
     EO_OP_FUNC(efl_model_properties_get, NULL, "Get properties from model."),
     EO_OP_FUNC(efl_model_property_set, NULL, "Set a property value of a given property name."),
     EO_OP_FUNC(efl_model_property_get, NULL, "Retrieve the value of a given property name."),
     EO_OP_FUNC(efl_model_children_slice_get, NULL, "Get children slice OR full range."),
     EO_OP_FUNC(efl_model_children_count_get, NULL, "Get children count."),
     EO_OP_FUNC(efl_model_load, NULL, "Load emodel."),
     EO_OP_FUNC(efl_model_unload, NULL, "Unload emodel."),
     EO_OP_FUNC(efl_model_properties_load, NULL, "Properties emodel load."),
     EO_OP_FUNC(efl_model_children_load, NULL, "Children emodel load."),
     EO_OP_FUNC(efl_model_child_add, NULL, "Add a new child."),
     EO_OP_FUNC(efl_model_child_del, NULL, "Remove a child."),
     EO_OP_SENTINEL
};

static const Eo_Event_Description *_efl_model_base_event_desc[] = {
     EFL_MODEL_BASE_EVENT_LOAD_STATUS,
     EFL_MODEL_BASE_EVENT_PROPERTIES_CHANGED,
     EFL_MODEL_BASE_EVENT_CHILD_ADDED,
     EFL_MODEL_BASE_EVENT_CHILD_REMOVED,
     EFL_MODEL_BASE_EVENT_CHILDREN_COUNT_CHANGED,
     NULL
};

static const Eo_Class_Description _efl_model_base_class_desc = {
     EO_VERSION,
     "Efl_Model_Base",
     EO_CLASS_TYPE_INTERFACE,
     EO_CLASS_DESCRIPTION_OPS(_efl_model_base_op_desc),
     _efl_model_base_event_desc,
     0,
     NULL,
     NULL
};

EO_DEFINE_CLASS(efl_model_base_interface_get, &_efl_model_base_class_desc, NULL, NULL);